package de.bananaco.webgui;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.HashSet;

import org.bukkit.entity.Player;

import com.bpermissions.gui.util.JSONWorldManager;

public final class RequestHandler extends Thread {
	
	/**
	 * The socket we are using to obtain a request.
	 */
	private final Socket socket;
	private final String username = WebGUI.instance.username;
	private final String passhash = WebGUI.instance.passhash;
	
	public RequestHandler(Socket socket) {
		this.socket = socket;
	}

	/**
	 * Listens for a request.
	 */
	public void run() {
		try {
			BufferedReader reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
			PrintWriter writer = new PrintWriter(socket.getOutputStream());
			String addr = socket.getInetAddress().getHostAddress();
			if(!isAllowed(addr)) {
				System.err.println("Failed login (BAD IP) with ip: "+addr);
				socket.close();
				return;
			}
			// Read the request and handle it.
			String action = reader.readLine();
			String username = reader.readLine();
			String pass = reader.readLine();
			String data = reader.readLine();
			
			if(!username.equals(this.username)) {
				System.err.println("Failed login (BAD USERNAME) with username: "+username);
				socket.close();
				return;
			}
			if(!pass.equals(this.passhash)) {
				System.err.println("Failed login (BAD PASSWORD) with username: "+username);
				System.err.println("Expected "+this.passhash+" got "+pass);
				socket.close();
				return;
			}
			if(action.equals("read")) {
				// Write a line of data
				data = new JSONStringWriter().encode();
				writer.write(data+"\n");
				writer.close();
			} else if(action.equals("write")) {
				// Write a line of data
				writer.write("{}\n");
				writer.close();	
				// Handle the data we received
				JSONWorldManager jwm = new JSONWorldManager(data);
				// This should update... well everything
				jwm.decode();
			}
			// Finally close the socket.
			socket.close();
		} catch (IOException ignored) {
		} catch (Exception ex) {
		ex.printStackTrace();
		}
	}
	
	public boolean isAllowed(String ip) {
		HashSet<String> allowed = WebGUI.instance.allowed;
		for(Player player : WebGUI.instance.getServer().getOnlinePlayers()) {
			if(player.hasPermission("bPermissions.gui")) {
				String newIp = player.getAddress().getAddress().getHostAddress();
				allowed.add(newIp);
				}
			}
		for(String allow : allowed) {
			if(allow.equals(ip))
				return true;
		}
		return false;
	}
	
}